Essential CSS
JavaScript Roadmap
Learn JavaScript
Mastering Web Typography
Practical Astro
Understanding Async JS
Unorthodox Tailwind
API Masterclass
Build and Deploy
The Beginner Freelancer
Real World Node
Profile Billing Logout
Understanding Async JS
Lesson Plan
  1. Introduction
    1. What is Asynchronous JS?
    2. Callbacks are not automatically asynchronous
    3. What is an API?
    4. Evolution of HTTP APIs
    5. Ajax vs Asynchronous JavaScript
  2. Fundamental Concepts
    1. How to fetch resources
    2. Using XHR
    3. Using the Fetch API
    4. Using libraries
    5. Core JavaScript concepts
    6. Understanding Promises
    7. Understanding Async Functions
    8. Understanding the Event Loop
    9. Understanding JSON
    10. Async JS Best Practices
    11. Using Optimistic UI
  3. Understanding Rest API
    1. Diving into Rest APIs
    2. The Rest Architecture
    3. The Rest Structure
    4. Anatomy of a Request
    5. What's an endpoint
    6. Request methods
    7. Understanding request headers
    8. Understanding the request body
    9. Authentication
    10. Basic Authentication
    11. Bearer Authentication
    12. Authenticating with API keys and API Secrets
    13. Cross Origin Resource Sharing
    14. Anatomy of a response
    15. HTTP Statuses
    16. Response headers
    17. The response body
    18. Handling Errors
    19. Reading API documentations
    20. Understanding Curl
  4. Node Basics
    1. Why we are using Node
    2. Command Line Basics
    3. Installing Node
    4. Managing dependencies
    5. Using ES Modules in Node
    6. Using Node
    7. Restarting the server automatically
    8. Sending requests via Node
    9. Protecting API keys and secrets
  5. Building a server
    1. What's a server
    2. Building a simple server with Express
    3. Two kinds of servers
    4. API Server architecture
    5. Handling routes
    6. Understanding Middlewares
    7. Enabling CORS
    8. Receiving data
    9. Sending responses
    10. Handling errors in Express
    11. Using the server as a proxy
    12. Minimum viable server
  6. Open Authorization
    1. Open Authorisation (OAuth)
    2. Authenticating with Access Tokens
    3. Obtaining Access Tokens
    4. Public and Confidential Clients
    5. Authorisation Code Grant
    6. Understanding scope
    7. Proof Key for Code Exchange (PKCE)
    8. PKCE with Twitter
    9. Dynamic state and `code_verifier`
    10. Saving the access token in cookies
    11. Passing access tokens to the browser
    12. Saving the access token in local storage
    13. Refresh Token Grant
    14. Device Code Grant
    15. Client libraries vs REST
  7. Building Social Media Logins
    1. Introduction
    2. Starter Files
    3. Creating SSL certificates
    4. Login in with Github
    5. Github: Saving the token to local storage
    6. Github: Persisting the login status
    7. Login with Twitter
    8. Twitter: Saving the token to local storage
    9. Twitter: Persisting the login status
    10. Twitter: Refreshing the access token
    11. Login with Facebook
    12. Facebook: Saving the token to localStorage
    13. Facebook: Persisting the login status
    14. Facebook: Refreshing the access token
    15. Login with google
    16. Google: Saving the token to localStorage
    17. Google: Refreshing the access token

Bearer Authentication

2m:3s

When you let a user log in with a token, we say you are using Bearer Authentication.

What are tokens?

A token is a string that can contain a lot of information.

It can contain information about:

  • A user’s login credentials
  • The token’s metadata (including creation and expiry time)
  • The amount of permissions given to the bearer of the token
  • Or anything the developer wants to encode into the token.

There are many kinds of tokens too, for example:

  • ID tokens
  • Access tokens
  • Refresh tokens
  • Bearer tokens
  • etc…

Don’t worry about the names of these tokens. They’re mostly semantics that either tell you how they are created or what they are used for.

Note

You don’t need to know how to create these tokens. You just have to know how to get and use them.

How to get tokens

There are two ways to get tokens:

  1. Through the app’s interface
  2. With Open Authorization

Getting tokens through the app

Many web apps let you create access tokens through their interface.

For example, GitHub lets you create a personal access token.

Twitter lets you create a bearer token too.

Note

Some applications ask you to retrieve an access token from another app and insert that into theirs.

This is a valid strategy if users are tech-savvy enough to create access tokens.

Getting tokens with Open Authorization

Open Authorization (OAuth for short) is the industry standard way to get tokens.

It’s the technology that:

  • Lets you log in with services like Facebook, GitHub, Google, Twitter, and many others.
  • Lets you determine what permissions you want to give to apps

We will cover OAuth in depth in a later chapter.

For now, just know that you can get tokens through OAuth as well.

How to use tokens

To use tokens for authentication, you send an Authorisation header that contains Bearer (with a space) value, followed by the token value.

fetch('https://link-to-resource', {
headers: {
Authorization: `Bearer ${token}`,
},
})

If you use zlFetch, the process is simpler since it creates the Authorization header for you — all you need to do is pass an auth property with the token value.

zlFetch('https://link-to-resource', {
auth: token,
})

That’s all you need to know about Bearer Authentication.

Next, we’ll talk about authenticating with API keys and secrets.